#!/usr/bin/perl

use warnings;
use strict;

use Net::OAuth;
$Net::OAuth::PROTOCOL_VERSION = Net::OAuth::PROTOCOL_VERSION_1_0A;
use HTTP::Request::Common;
use LWP::UserAgent;
use Data::Dumper;
use Encode;
use URI::Escape;
use Data::Random qw(rand_chars);
require "functions.pl";
#use JSON qw( to_json from_json );

my $memcache;

my $ua = LWP::UserAgent->new();
$ua->env_proxy;

my %sapo_urls = %{get_sapo_urls()};


get_authz('http://localhost/aaa');



sub get_authz {
    #my ($callback) = @_;

        my $callback = 'http://localhost/aaa';


    my $request = Net::OAuth->request("request token")->new(
        &default_request_params_sapo,
        request_url       => $sapo_urls{'request_token'},
        callback          => $callback,
    );

     $request->{extra_params}={
            oauth_callback       => $callback,
     };


    $request->sign;

    my $res = $ua->request(GET $request->to_url); # Post message to the Service Provider


    my $request_token;
    my $token_secret;


    if ($res->is_success) {
        my $response = Net::OAuth->response('request token')->from_post_body($res->content);
        $request_token=$response->token;
        $token_secret=$response->token_secret;
    }

    warn "error getting token_secret" unless ($request_token && $token_secret);


    my $url_to_authorize=$sapo_urls{'authorize'} .
                        '?oauth_callback=' . URI::Escape::uri_escape_utf8($callback, '^\w.~-') .
                         '&oauth_token=' . $request_token;

	print "url_to_authorize: " . $url_to_authorize . "\n";
	print "token_secret: " . $token_secret ."\n";

}

